<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014  Yuri Kuznetsov, Taras Machyshyn, Oleksiy Avramenko
 * Website: http://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 ************************************************************************/

class AfterInstall
{
    protected $container;

    public function run($container)
    {
        $this->container = $container;

        $config = $this->container->get('config');

        $tabList = $config->get('tabList', []);

        if (!in_array('RealEstateRequest', $tabList)) {
            array_unshift($tabList, 'RealEstateRequest');
        }
        if (!in_array('RealEstateProperty', $tabList)) {
            array_unshift($tabList, 'RealEstateProperty');
        }

        $quickCreateList = $config->get('quickCreateList', []);

        if (!in_array('RealEstateRequest', $quickCreateList)) {
            array_unshift($quickCreateList, 'RealEstateRequest');
        }
        if (!in_array('RealEstateRequest', $quickCreateList)) {
            array_unshift($quickCreateList, 'RealEstateRequest');
        }


        $globalSearchEntityList = $config->get('globalSearchEntityList', []);

        if (!in_array('RealEstateRequest', $globalSearchEntityList)) {
            array_unshift($globalSearchEntityList, 'RealEstateRequest');
        }
        if (!in_array('RealEstateProperty', $globalSearchEntityList)) {
            array_unshift($globalSearchEntityList, 'RealEstateProperty');
        }

        if (!in_array('Opportunity', $globalSearchEntityList)) {
            $globalSearchEntityList[] = 'Opportunity';
        }
        if (!in_array('Contact', $globalSearchEntityList)) {
            $globalSearchEntityList[] = 'Contact';
        }
        if (!in_array('Account', $globalSearchEntityList)) {
            $globalSearchEntityList[] = 'Account';
        }

        $config->set('tabList', $tabList);
        $config->set('quickCreateList', $quickCreateList);
        $config->set('globalSearchEntityList', $globalSearchEntityList);
        $config->set('saleMarkup', 5);
        $config->set('rentMarkup', 50);

        $config->save();

        $this->clearCache();
    }

    protected function clearCache()
    {
        try {
            $this->container->get('dataManager')->clearCache();
        } catch (\Exception $e) {}
    }
}
